/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.TipoOcupacion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoOcupacion;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoOcupacionController")
@Scope("prototype")
public class BusquedaTipoOcupacionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoOcupacion> plwTipoOcupacion;
    private MyListbox tipoOcupacionList;
    private Paging pagingTipoOcupacion;
    private Textbox txtNome;
    private Textbox txtCve;

    public Paging getPagingTipoOcupacion() {
        return pagingTipoOcupacion;
    }

    public void setPagingTipoOcupacion(Paging pagingTipoOcupacion) {
        this.pagingTipoOcupacion = pagingTipoOcupacion;
    }

    public MyListbox getTipoOcupacionList() {
        return tipoOcupacionList;
    }

    public void setTipoOcupacionList(MyListbox tipoOcupacionList) {
        this.tipoOcupacionList = tipoOcupacionList;
    }

    public Textbox getTxtCve() {
        return txtCve;
    }

    public void setTxtCve(Textbox txtCve) {
        this.txtCve = txtCve;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoOcupacionList.setItemRenderer(new RenderTipoOcupacion());
        tipoOcupacionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoOcupacion a = (TipoOcupacion) tipoOcupacionList.getSelected();
                verTipoOcupacion(a);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verTipoOcupacion(TipoOcupacion a) {
        if (a == null) {
            return;
        }

        Map args = new HashMap();
        args.put("busquedaTipoOcupacionController", this);
        args.put("tipoOcupacion", a);
        args.put("tipoOcupacionList", tipoOcupacionList);

        openWindow("/gui/senda_amigo/editarTipoOcupacion.zul",
                Labels.getLabel("editarTipoOcupacionController.window.title"), args, MODAL);
    }

    public void refreshLista() {
        HibernateSearchObject<TipoOcupacion> tipoOcupacionBusqueda =
                new HibernateSearchObject<TipoOcupacion>(TipoOcupacion.class,
                pagingTipoOcupacion.getPageSize());

        if (!txtNome.getText().isEmpty()) {
            tipoOcupacionBusqueda.addFilterLike("desctipo",
                    "%" + txtNome.getText().trim().concat("%"));
        }

        if (!txtCve.getText().isEmpty()) {
            tipoOcupacionBusqueda.addFilterEqual("cvetipoocupacion", txtCve.getText());
        }

        tipoOcupacionBusqueda.addSortAsc("desctipo");
        tipoOcupacionBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwTipoOcupacion.init(tipoOcupacionBusqueda, tipoOcupacionList, pagingTipoOcupacion);

        if (tipoOcupacionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoOcupacionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoOcupacion(new TipoOcupacion());
    }
}
